# pip wheel

Contents

- pip wheel
  - Usage
  - Description
    - Build System Interface
      - Customising the build
  - Options
  - Examples

## Usage

    pip wheel [options] <requirement specifier> ...
    pip wheel [options] -r <requirements file> ...
    pip wheel [options] [-e] <vcs project url> ...
    pip wheel [options] [-e] <local project path> ...
    pip wheel [options] <archive url/path> ...

## Description

Build Wheel archives for your requirements and dependencies.

Wheel is a built-package format, and offers the advantage of not recompiling your software during every install. For more details, see the wheel docs: http://wheel.readthedocs.org/en/latest.

Requirements: setuptools>=0.8, and wheel.

'pip wheel' uses the bdist_wheel setuptools extension from the wheel package to build individual wheels.

### Build System Interface

In order for pip to build a wheel, `setup.py` must implement the `bdist_wheel` command with the following syntax:

    python setup.py bdist_wheel -d TARGET

This command must create a wheel compatible with the invoking Python interpreter, and save that wheel in the directory TARGET.

No other build system commands are invoked by the `pip wheel` command.

#### Customising the build

It is possible using `--global-option` to include additional build commands with their arguments in the `setup.py` command. This is currently the only way to influence the building of C extensions from the command line. For example:

    pip wheel --global-option bdist_ext --global-option -DFOO wheel

will result in a build command of

    setup.py bdist_ext -DFOO bdist_wheel -d TARGET

which passes a preprocessor symbol to the extension build.

Such usage is considered highly build-system specific and more an accident of the current implementation than a supported interface.

## Options

`-w````,` `--wheel-dir``<dir>`

  Build wheels into <dir>, where the default is the current working directory.

`--no-use-wheel```

  Do not Find and prefer wheel archives when searching indexes and find-links locations. DEPRECATED in favour of --no-binary.

`--no-binary``<format_control>`

  Do not use binary packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either :all: to disable all binary packages, :none: to empty the set, or one or more package names with commas between them. Note that some packages are tricky to compile and may fail to install when this option is used on them.

`--only-binary``<format_control>`

  Do not use source packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either :all: to disable all source packages, :none: to empty the set, or one or more package names with commas between them. Packages without binary distributions will fail to install when this option is used on them.

`--build-option``<options>`

  Extra arguments to be supplied to 'setup.py bdist_wheel'.

`-c````,` `--constraint``<file>`

  Constrain versions using the given constraints file. This option can be used multiple times.

`-e````,` `--editable``<path/url>`

  Install a project in editable mode (i.e. setuptools "develop mode") from a local project path or a VCS url.

`-r````,` `--requirement``<file>`

  Install from the given requirements file. This option can be used multiple times.

`--src``<dir>`

  Directory to check out editable projects into. The default in a virtualenv is "<venv path>/src". The default for global installs is "<current dir>/src".

`--no-deps```

  Don't install package dependencies.

`-b````,` `--build``<dir>`

  Directory to unpack packages into and build in.

`--global-option``<options>`

  Extra global options to be supplied to the setup.py call before the 'bdist_wheel' command.

`--pre```

  Include pre-release and development versions. By default, pip only finds stable versions.

`--no-clean```

  Don't clean up build directories.

`--require-hashes```

  Require a hash to check each requirement against, for repeatable installs. This option is implied when any package in a requirements file has a --hash option.

`-i````,` `--index-url``<url>`

  Base URL of Python Package Index (default https://pypi.python.org/simple).

`--extra-index-url``<url>`

  Extra URLs of package indexes to use in addition to --index-url.

`--no-index```

  Ignore package index (only looking at --find-links URLs instead).

`-f````,` `--find-links``<url>`

  If a url or path to an html file, then parse for links to archives. If a local path or file:// url that's a directory, then look for archives in the directory listing.

`--process-dependency-links```

  Enable the processing of dependency links.

## Examples

1. Build wheels for a requirement (and all its dependencies), and then install

>     $ pip wheel --wheel-dir=/tmp/wheelhouse SomePackage
>     $ pip install --no-index --find-links=/tmp/wheelhouse SomePackage